Bug 1891793 - python-ephem fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats
Summary: python-ephem fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN m...
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: python-ephem
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Fabian Affolter
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-10-27 11:43 UTC by Tomáš Hrnčiar
Modified: 2021-02-09 16:23 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-10-27 11:43:11 UTC
python-ephem fails to build with Python 3.10.0a1.

=================================== FAILURES ===================================
_______________________ FunctionTests.test_constellation _______________________

self = <ephem.tests.test_bodies.FunctionTests testMethod=test_constellation>

    def test_constellation(self):
        oneb = readdb('Orion Nebula,f,5.59,-5.45,2,2000.0,')
        oneb.compute('1999/2/28')
>       self.assertEqual(constellation(oneb), ('Ori', 'Orion'))
E       SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats

tests/test_bodies.py:309: SystemError
=============================== warnings summary ===============================
tests/test_bodies.py:20
  /builddir/build/BUILDROOT/python-ephem-3.7.7.1-4.fc34.x86_64/usr/lib64/python3.10/site-packages/ephem/tests/test_bodies.py:20: PytestCollectionWarning: cannot collect test class 'TestError' because it has a __init__ constructor (from: tests/test_bodies.py)
    class TestError(Exception):

tests/test_satellite.py::SatelliteTests::test_TLE_checksum
  /builddir/build/BUILDROOT/python-ephem-3.7.7.1-4.fc34.x86_64/usr/lib64/python3.10/site-packages/ephem/tests/test_satellite.py:24: DeprecationWarning: Please use assertRaisesRegex instead.
    self.assertRaisesRegexp(ValueError, expected, ephem.readtle, *lines)

-- Docs: https://docs.pytest.org/en/stable/warnings.html
=========================== short test summary info ============================
FAILED tests/test_bodies.py::FunctionTests::test_constellation - SystemError:...
====== 1 failed, 131 passed, 2 skipped, 2 deselected, 2 warnings in 2.26s ======
error: Bad exit status from /var/tmp/rpm-tmp.J50m0s (%check)
    Bad exit status from /var/tmp/rpm-tmp.J50m0s (%check)

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01721772-python-ephem/

For all our attempts to build python-ephem with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-ephem/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2020-10-27 12:15:05 UTC
https://docs.python.org/3.10/whatsnew/3.10.html#id2

The PY_SSIZE_T_CLEAN macro must now be defined to use PyArg_ParseTuple() and Py_BuildValue() formats which use #: es#, et#, s#, u#, y#, z#, U# and Z#. See Parsing arguments and building values and the PEP 353. https://bugs.python.org/issue40943

Comment 2 Ben Cotton 2021-02-09 15:21:45 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.


Note You need to log in before you can comment on or make changes to this bug.